// ThermoPONG

#define F_CPU 8000000UL	  

#include <stdlib.h>
#include <inttypes.h>	
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/io.h>
#include <util/delay.h>	
#include <avr/pgmspace.h>
#include <stdio.h>
#include "pong_number_display.h" 


unsigned long	t;			// temperature
char 			text[3];	// display text
unsigned int 	offset = 281;	// offset for AD22100
unsigned int 	slope  = 217;	// slope for AD22100

int main(void)
{	// port configuration
	DDRC = 0x0f;   //  PORTC = AD-Input
	DDRB = 0xff;   //  PortB = Output
	DDRD = 0xff;   //  PortD = Output
	
	// initialize ADC
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);  	// Prescaler=64 (8 MHz/64=125 kHz)  
	ADMUX |= (1<<REFS0) | (1<<REFS1); 				// internal reference
	ADCSRA |= (1<<ADSC);							// single conversion
	sei();					
	
	InitMatrix();

	while (1)
	{	ADMUX = 0x06;					// select channel (ADC6)	
		ADCSRA |= (1<<ADSC);			// single conversion
		while ( ADCSRA & (1<<ADSC) );	// wait for ADC ready 
		t = (ADCW-offset)*slope/1000;	// scale result
		itoa(t,text,10);				// convert result to ASCII
		if (t<10) WriteMatrix(text,6,3);// display result at correct position
 		else WriteMatrix(text,2,3);
		_delay_ms(200);
		ClearMatrix();
	}
}
